#! /usr/bin/perl
#
#  gettile.pl:		uh, Fri May 15 1998
#
#  Written by:		Ullrich Hafner
#  
#  Copyright (C) 1998 Ullrich Hafner <hafner@informatik.uni-wuerzburg.de>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
#
#  $Id: gettile.pl.in,v 1.2 1998/07/30 20:25:57 hafner Exp $
#  $Date: 1998/07/30 20:25:57 $
#  $Author: hafner $
#  $Revision: 1.2 $
#  $State: Exp $
#

##############################################################################
###
###	usage : gettile.pl WindowMaker-filename tile-filename
### 
###     gets tile of the day via HTTP request from http://themes.org/
###     Links `tile-filename' to the received tile und updates
###     WindowMaker-filename.
###     'tile-filename' must be tile-of-the-day, random-tile, or, guest-tile
###
##############################################################################

die "usage: $0 WindowMaker-filename tile-filename" if $#ARGV != 1;

$windowmaker = $ARGV[0];
$tilename    = $ARGV[1];

$lynx      = "/usr/bin/lynx";
$getscript = "lynx.pl";
$include   = $0;
$include   =~ s/gettile.pl/$getscript/;

if ($tilename =~ /tile-of-the-day/) # tile of the day
{
   $tval  = time;
   $tval -= 60 * 60 * 6;	# new tile at 0:00 CST (diff: max. 6 hours)
   @today = gmtime $tval;
   @month = ("Jan", "Feb", "Mar", "Apr", "May", "Jun",
	     "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
   $date  = "$month[$today[4]]$today[3]";
   
   $url  = "http://themes.org/totd/archive/Tile.$date.jpg";
}
else				# random tiles for masses
{
   if ($tilename =~ /random-tile/)
   {
      $url  = "http://themes.org/rtfm/";
      $file = $tilename;
      $file =~ s/random-tile/tile.html/;
   }
   elsif ($tilename =~ /guest-tile/)
   {
      $url  = "http://themes.org/totd/guest/";
      $file = $tilename;
      $file =~ s/guest-tile/tile.html/;
   }

   # get corresponding tile HTML page
   do "$include"; 
   die "$@" if $@;

   # find text background="tilename"	random-tile
   # find text guest/archive		guest-tile
   open (RTFM, $file) || die "Can't open File : $!";

   $url = "";
   while (<RTFM>)
   {
      if (($tilename =~ /random-tile/)
	  && (/background=["]([^"]*)\"/))
      {
         $url = $1;
	 unless ($url =~ /http/)
	 {
	    $url = "http://themes.org/rtfm/$url";
	 }
         break;
      }
      elsif (($tilename =~ /guest-tile/)
	     && (/img.*src.*["](.*guest\/archive\/[^"]*)\"/))
      {
         $url = $1;
         break;
      }
   }
   close RTFM;
   unlink $file;
   
   # rtfm tile name
   if ($url eq "")
   {
      $url = "http://themes.org/totd/archive/Tile.Jun18.jpg"; # default
   }
}

# get new tile with libwww-perl or lynx
$file = $tilename;
do "$include"; 
die "$@" if $@;

# update WindowMaker file unless $windowmaker = "no"

unless ($windowmaker eq "no")
{
   $color = 0;
   open (WM, "$windowmaker") || die "Can't open File : $!";
   open (TMP_WM, ">$windowmaker.tmp") || die "Can't open File : $!";
   while (<WM>)
   {
      if (/IconBack.*,.*,.*\#[a-f0-9]{5}?([a-f0-9])/i)
      {
	 $char = lc ($1);
	 %f = ("a" => "b", "b" => "a", "c" => "d", "d" => "c", "e" => "f",
	       "f" => "e", "0" => "1", "1" => "0", "2" => "3", "3" => "2",
	       "4" => "5", "5" => "4", "6" => "7", "7" => "6", "8" => "9",
	       "9" => "8");
	 s/(IconBack.*,.*,.*\#[a-f0-9]{5}?)([a-f0-9])/$1$f{$char}/i;
	 $color = 1;
      }
      print TMP_WM;
   }
   close TMP_WM;
   close WM;

   if ($color)			# simple update with new color
   {
      unlink ("$windowmaker") || die "Can't delete `$windowmaker'";
      rename ("$windowmaker.tmp", "$windowmaker")
	|| die "Can't rename `$windowmaker.tmp' to `$windowmaker'";
   }
   else
   {
      open (TMP_WM, "$windowmaker.tmp") || die "Can't open File : $!";
      open (WM, ">$windowmaker") || die "Can't open File : $!";
      
      while (<TMP_WM>)
      {
	 s/tile-of-the-day/$file/;
	 s/random-tile/$file/;
	 s/guest-tile/$file/;
	 print WM;
      }
      close TMP_WM;
      close WM;
      
      sleep 5;			# give wmaker a chance to realize change
      
      open (TMP_WM, "$windowmaker.tmp") || die "Can't open File : $!";
      open (WM, ">$windowmaker") || die "Can't open File : $!";
      while (<TMP_WM>)
      {
	 print WM;
      }
      close TMP_WM;
      close WM;
   }
}

sub quit
{
   $msg = shift;
   die "$msg";
}
